cookutils annotate cook @ rev 177

cook: get source from our mirror if missing (Thank Pascal for the patch)
author Christophe Lincoln <pankso@slitaz.org>
date Wed May 18 12:33:12 2011 +0200 (2011-05-18)
parents 93fff152169d
children 405d1f3716ed
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@172 19 # Old style compatibility
pankso@172 20 SOURCES_REPOSITORY=$SRC
pankso@172 21
pankso@1 22 #
pankso@1 23 # Functions
pankso@1 24 #
pankso@1 25
pankso@1 26 usage() {
pankso@1 27 cat << EOT
pankso@1 28
pankso@147 29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
pankso@1 30
pankso@1 31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
pankso@1 32 usage|help $(gettext "Display this short usage.")
pankso@1 33 setup $(gettext "Setup your build environment.")
pankso@9 34 test $(gettext "Test environment and cook a package.")
pankso@69 35 list-wok $(gettext "List packages in the wok.")
pankso@69 36 search $(gettext "Simple packages search function.")
paul@62 37 new $(gettext "Create a new package with a receipt".)
pankso@1 38 list $(gettext "Cook a list of packages.")
pankso@1 39 clean-wok $(gettext "Clean-up all packages files.")
paul@62 40 clean-src $(gettext "Clean-up all packages sources.")
pankso@1 41 pkglist $(gettext "Create all packages.* lists.")
pankso@1 42
pankso@1 43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
pankso@10 44 --clean|-c Cook : $(gettext "clean the package in the wok.")
pankso@39 45 --install|-i Cook : $(gettext "cook and install the package.")
pankso@39 46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
pankso@49 47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
pankso@49 48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@10 49 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
pankso@1 50
pankso@1 51 EOT
pankso@1 52 exit 0
pankso@1 53 }
pankso@1 54
paul@62 55 # Be sure we're root.
pankso@1 56 check_root() {
pankso@1 57 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 58 }
pankso@1 59
pankso@1 60 separator() {
pankso@1 61 echo "================================================================================"
pankso@1 62 }
pankso@1 63
pankso@1 64 status() {
pankso@1 65 echo -en "\\033[70G[ "
pankso@1 66 if [ $? = 0 ]; then
pankso@1 67 echo -en "\\033[1;32mOK"
pankso@1 68 else
pankso@1 69 echo -en "\\033[1;31mFailed"
pankso@1 70 fi
pankso@1 71 echo -e "\\033[0;39m ]"
pankso@1 72 }
pankso@1 73
pankso@13 74 # Log activities, we want first letter capitalized.
pankso@9 75 log() {
pankso@27 76 grep ^[A-Z] | \
pankso@9 77 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 78 }
pankso@9 79
paul@62 80 # We don't want these escapes in web interface.
pankso@1 81 clean_log() {
pankso@1 82 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 83 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 84 }
pankso@1 85
pankso@23 86 # Log broken packages.
pankso@23 87 broken() {
pankso@74 88 if ! grep -q "^$pkg$" $broken; then
pankso@74 89 echo "$pkg" >> $broken
pankso@74 90 fi
pankso@23 91 }
pankso@23 92
paul@62 93 # Be sure package exists in wok.
pankso@1 94 check_pkg_in_wok() {
pankso@1 95 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 96 gettext -e "\nUnable to find package in the wok:"
pankso@1 97 echo -e " $pkg\n" && exit 1
pankso@1 98 fi
pankso@1 99 }
pankso@1 100
pankso@9 101 if_empty_value() {
pankso@9 102 if [ -z "$value" ]; then
pankso@9 103 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 104 exit 1
pankso@9 105 fi
pankso@9 106 }
pankso@9 107
paul@62 108 # Initialize files used in $CACHE
pankso@52 109 init_db_files() {
pankso@52 110 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 111 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 112 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 113 for f in $activity $command $broken $blocked
pankso@52 114 do
pankso@52 115 touch $f
pankso@52 116 done
pankso@52 117 }
pankso@52 118
paul@62 119 # QA: check a receipt consistency before building.
pankso@9 120 receipt_quality() {
pankso@9 121 gettext -e "QA: checking package receipt...\n"
pankso@9 122 unset online
pankso@9 123 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 124 online="online"
pankso@9 125 fi
pankso@9 126 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 127 do
pankso@9 128 unset value
pankso@44 129 value=$(grep ^$var= $receipt | cut -d \" -f 2)
pankso@9 130 case "$var" in
pankso@9 131 PACKAGE|VERSION|SHORT_DESC)
pankso@9 132 if_empty_value ;;
pankso@9 133 CATEGORY)
pankso@9 134 [ -z "$value" ] && value="empty"
pankso@9 135 valid="base-system x-window utilities network graphics \
pankso@9 136 multimedia office development system-tools security games \
pankso@9 137 misc meta non-free"
pankso@9 138 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 139 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 140 exit 1
pankso@9 141 fi ;;
pankso@9 142 WEB_SITE)
paul@62 143 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 144 # Break also if we're not online. Here error is not fatal.
pankso@9 145 if_empty_value
pankso@9 146 [ -z "$online" ] || break
pankso@9 147 if ! busybox wget -s $value 2>/dev/null; then
pankso@61 148 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 149 fi ;;
pankso@9 150 esac
pankso@9 151 done
pankso@9 152 }
pankso@9 153
pankso@9 154 # Executed before sourcing a receipt.
pankso@9 155 unset_receipt() {
pankso@9 156 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 157 }
pankso@9 158
paul@62 159 # Paths used in receipt and by cook itself.
pankso@1 160 set_paths() {
pankso@1 161 pkgdir=$WOK/$PACKAGE
pankso@1 162 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 163 taz=$pkgdir/taz
pankso@44 164 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 165 fs=$pack/fs
pankso@1 166 stuff=$pkgdir/stuff
pankso@1 167 install=$pkgdir/install
pankso@1 168 if [ "$WANTED" ]; then
pankso@1 169 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 170 install=$WOK/$WANTED/install
pankso@121 171 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 172 fi
pankso@9 173 # Old way compatibility.
pankso@1 174 _pkg=$install
pankso@1 175 }
pankso@1 176
pankso@144 177 # Create source tarball when URL is a SCM.
pankso@144 178 create_tarball() {
pankso@144 179 gettext "Creating tarball: "; echo "$tarball"
pankso@162 180 if [ "$LZMA_SRC" ]; then
pankso@162 181 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
pankso@162 182 else
pankso@162 183 tar cjf $tarball $pkgsrc || exit 1
pankso@162 184 mv $tarball $SRC && rm -rf $pkgsrc
pankso@162 185 fi
pankso@144 186 }
pankso@144 187
pankso@145 188 # Get package source. For SCM we are in cache so clone here and create a
pankso@145 189 # tarball here.
pankso@1 190 get_source() {
pankso@115 191 pwd=$(pwd)
pankso@144 192 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@144 193 tarball=$pkgsrc.tar.bz2
pankso@162 194 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
pankso@9 195 case "$WGET_URL" in
pankso@145 196 http://*|ftp://*)
pankso@9 197 # Busybox Wget is better!
pankso@145 198 busybox wget -c -P $SRC $WGET_URL || \
pankso@145 199 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@145 200 https://*)
pankso@145 201 wget -c --no-check-certificate -P $SRC $WGET_URL || \
pankso@15 202 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 203 hg*|mercurial*)
pankso@29 204 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 205 url=${WGET_URL#hg|}
pankso@9 206 else
pankso@9 207 url=${WGET_URL#mercurial|}
pankso@9 208 fi
pankso@61 209 gettext -e "Getting source from Hg...\n"
pankso@61 210 echo "URL: $url"
pankso@9 211 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@15 212 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@144 213 create_tarball ;;
pankso@9 214 git*)
pankso@61 215 url=${WGET_URL#git|}
pankso@61 216 gettext -e "Getting source from Git...\n"
pankso@61 217 echo "URL: $url"
pankso@64 218 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 219 if [ "$BRANCH" ]; then
pankso@146 220 echo "Git branch: $BRANCH"
pankso@64 221 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 222 fi
pankso@144 223 create_tarball ;;
pankso@144 224 cvs*)
pankso@144 225 url=${WGET_URL#cvs|}
pankso@144 226 mod=$PACKAGE
pankso@144 227 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
pankso@144 228 gettext -e "Getting source from CVS...\n"
pankso@144 229 echo "URL: $url"
pankso@146 230 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
pankso@144 231 gettext "Cloning to: "; echo "$pwd/$mod"
pankso@144 232 cvs -d:$url co $mod && mv $mod $pkgsrc
pankso@144 233 create_tarball ;;
pankso@69 234 svn*|subversion*)
pankso@159 235 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
pankso@146 236 url=${WGET_URL#svn|}
pankso@146 237 else
pankso@146 238 url=${WGET_URL#subversion|}
pankso@146 239 fi
pankso@146 240 gettext -e "Getting source from SVN...\n"
pankso@146 241 echo "URL: $url"
pankso@161 242 if [ "$BRANCH" ]; then
pankso@161 243 echo t | svn co $url -r $BRANCH $pkgsrc
pankso@161 244 else
pankso@161 245 echo t | svn co $url $pkgsrc
pankso@161 246 fi
pankso@146 247 create_tarball ;;
pankso@9 248 *)
pankso@9 249 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 250 tee -a $LOGS/$PACKAGE.log
pankso@9 251 exit 1 ;;
pankso@9 252 esac
pankso@1 253 }
pankso@1 254
pankso@9 255 # Extract source package.
pankso@1 256 extract_source() {
pankso@177 257 if [ ! -s "$SRC/$TARBALL" ]; then
pankso@177 258 local url
pankso@177 259 url="http://mirror.slitaz.org/sources/packages"
pankso@177 260 url=$url/${TARBALL:0:1}/$TARBALL
pankso@177 261 gettext "Getting source from mirror:"; echo " $url"
pankso@177 262 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
pankso@177 263 fi
pankso@1 264 gettext "Extracting:"; echo " $TARBALL"
pankso@1 265 case "$TARBALL" in
pankso@120 266 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@120 267 *.tar.bz2|*.tbz) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 268 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 269 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 270 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 271 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 272 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 273 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@1 274 esac
pankso@1 275 }
pankso@1 276
pankso@9 277 # Display cooked package summary.
pankso@1 278 summary() {
pankso@1 279 cd $WOK/$pkg
pankso@1 280 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 281 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 282 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 283 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 284 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 285 sec=$time
pankso@104 286 div=$(($time / 60))
pankso@112 287 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 288 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 289 separator
pankso@67 290 [ "$prod" ] && echo "Produced : $prod"
pankso@1 291 cat << EOT
pankso@1 292 Packed : $fs
pankso@1 293 Compressed : $size
pankso@18 294 Files : $files
pankso@102 295 Cook time : ${sec}s $min
pankso@18 296 Cook date : $cookdate
pankso@1 297 $(separator)
pankso@1 298 EOT
pankso@1 299 }
pankso@1 300
paul@62 301 # Display debugging error info.
pankso@15 302 debug_info() {
pankso@17 303 echo -e "\nDebug information"
pankso@15 304 separator
pankso@48 305 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 306 for error in \
pankso@77 307 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 308 "error:" "fatal error:"
pankso@34 309 do
pankso@34 310 fgrep "$error" $LOGS/$pkg.log
pankso@34 311 done
pankso@15 312 separator && echo ""
pankso@15 313 }
pankso@15 314
pankso@1 315 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 316 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 317 copy_generic_files()
pankso@1 318 {
pankso@1 319 # $LOCALE is set in cook.conf
pankso@1 320 if [ "$LOCALE" ]; then
pankso@1 321 if [ -d "$_pkg/usr/share/locale" ]; then
pankso@1 322 mkdir -p $fs/usr/share/locale
pankso@1 323 for i in $LOCALE
pankso@1 324 do
pankso@1 325 if [ -d "$_pkg/usr/share/locale/$i" ]; then
pankso@1 326 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
pankso@1 327 fi
pankso@1 328 done
pankso@1 329 fi
pankso@1 330 fi
pankso@1 331
pankso@1 332 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 333 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@1 334 if [ -d "$_pkg/usr/share/pixmaps" ]; then
pankso@1 335 mkdir -p $fs/usr/share/pixmaps
pankso@1 336 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
pankso@1 337 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 338 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
pankso@1 339 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 340 fi
pankso@1 341
pankso@1 342 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 343 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 344 mkdir -p $fs/usr/share/pixmaps
pankso@1 345 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 346 fi
pankso@1 347 fi
pankso@1 348
pankso@1 349 # Desktop entry (.desktop).
pankso@1 350 if [ -d "$_pkg/usr/share/applications" ]; then
pankso@1 351 cp -a $_pkg/usr/share/applications $fs/usr/share
pankso@1 352 fi
pankso@1 353
pankso@1 354 # Homemade desktop file(s) can be in stuff.
pankso@1 355 if [ -d "$stuff/applications" ]; then
pankso@1 356 mkdir -p $fs/usr/share
pankso@1 357 cp -a $stuff/applications $fs/usr/share
pankso@1 358 fi
pankso@1 359 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 360 mkdir -p $fs/usr/share/applications
pankso@1 361 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 362 fi
pankso@1 363 }
pankso@1 364
pankso@67 365 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 366 # as removing uneeded files like in Python packages.
pankso@1 367 strip_package()
pankso@1 368 {
pankso@67 369 gettext "Executing strip on all files..."
pankso@1 370 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 371 do
pankso@1 372 if [ -d "$dir" ]; then
pankso@1 373 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 374 fi
pankso@1 375 done
pankso@1 376 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 377 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 378 status
pankso@67 379
pankso@117 380 # Remove Python .pyc and .pyo from packages.
pankso@150 381 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
pankso@68 382 gettext "Removing Python compiled files..."
pankso@67 383 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 384 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 385 status
pankso@117 386 fi
pankso@117 387
pankso@117 388 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 389 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 390 gettext "Removing Perl compiled files..."
pankso@67 391 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 392 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 393 status
pankso@67 394 fi
pankso@1 395 }
pankso@1 396
pankso@8 397 # Remove installed deps.
pankso@8 398 remove_deps() {
pankso@8 399 # Now remove installed build deps.
pankso@113 400 diff="$CACHE/installed.cook.diff"
pankso@113 401 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 402 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 403 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 404 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 405 gettext "Removing:"
pankso@8 406 for dep in $deps
pankso@8 407 do
pankso@8 408 echo -n " $dep"
pankso@8 409 yes | tazpkg remove $dep >/dev/null
pankso@8 410 done
pankso@16 411 echo -e "\n"
pankso@113 412 # Keep the last diff for debug and info.
pankso@113 413 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 414 fi
pankso@1 415 }
pankso@1 416
pankso@1 417 # The main cook function.
pankso@1 418 cookit() {
pankso@11 419 echo "Cook: $PACKAGE $VERSION"
pankso@9 420 separator
pankso@1 421 set_paths
pankso@9 422 [ "$QA" ] && receipt_quality
pankso@44 423 cd $pkgdir
pankso@33 424 rm -rf install taz source
pankso@1 425
pankso@1 426 # Disable -pipe if less than 512Mb free RAM.
pankso@1 427 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 428 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 429 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 430 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 431 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 432 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 433 fi
pankso@1 434 unset free
pankso@1 435
pankso@1 436 # Export flags and path to be used by make
pankso@44 437 DESTDIR=$pkgdir/install
pankso@1 438 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
pankso@1 439 local LC_ALL=POSIX LANG=POSIX
pankso@1 440
pankso@126 441 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 442 # (ex: libusb-dev :: libusb).
pankso@1 443 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@1 444 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 445 for dep in $BUILD_DEPENDS
pankso@1 446 do
pankso@126 447 implicit=${dep%-dev}
pankso@131 448 for i in $dep $implicit
pankso@126 449 do
pankso@131 450 if [ ! -f "$INSTALLED/$i/receipt" ]; then
paul@174 451 # Try local package first. In some cases implicit doesn't exist, ex:
paul@174 452 # libboost-dev exists but not libboost, so check if we got vers.
pankso@173 453 unset vers
pankso@173 454 vers=$(grep ^VERSION $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
pankso@131 455 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@131 456 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@131 457 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
pankso@126 458 else
pankso@173 459 if [ "$vers" ]; then
pankso@173 460 gettext "Installing dep (web/cache):"; echo " $i"
pankso@173 461 tazpkg get-install $i >/dev/null
pankso@173 462 fi
pankso@126 463 fi
pankso@1 464 fi
pankso@126 465 done
pankso@1 466 done
pankso@128 467 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@8 468
paul@62 469 # If a cook failed deps are not removed since we exit 1.
pankso@113 470 [ ! -s "installed.cook.diff" ] && \
pankso@141 471 busybox diff installed.list installed.cook > installed.cook.diff
pankso@113 472 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@1 473
pankso@1 474 # Get source tarball and make sure we have source dir named:
paul@62 475 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 476 # tarball if it exists.
pankso@1 477 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 478 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 479 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@1 480 else
pankso@1 481 get_source || exit 1
pankso@1 482 fi
pankso@1 483 fi
pankso@9 484 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 485 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pankso@1 486 extract_source || exit 1
paul@62 487 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 488 files=$(ls | wc -l)
pankso@57 489 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
pankso@57 490 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 491 mv * ../$PACKAGE-$VERSION
pankso@1 492 cd .. && rm -rf tmp
pankso@1 493 fi
pankso@1 494
pankso@9 495 # Execute receipt rules.
pankso@44 496 if grep -q ^compile_rules $receipt; then
pankso@1 497 gettext -e "Executing: compile_rules\n"
pankso@55 498 [ -d "$src" ] && cd $src
pankso@97 499 compile_rules $@ || exit 1
pankso@10 500 # Stay compatible with _pkg
pankso@55 501 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 502 # QA: compile_rules success so valid.
pankso@9 503 mkdir -p $install
pankso@9 504 else
pankso@9 505 # QA: No compile_rules so no error, valid.
pankso@9 506 mkdir -p $install
pankso@1 507 fi
pankso@1 508 separator && echo ""
pankso@1 509 }
pankso@1 510
pankso@1 511 # Cook quality assurance.
pankso@1 512 cookit_quality() {
pankso@9 513 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 514 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 515 fi
pankso@9 516 # ERROR can be echoed any time in cookit()
pankso@33 517 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 518 debug_info | tee -a $LOGS/$pkg.log
pankso@33 519 rm -f $command && exit 1
pankso@1 520 fi
pankso@1 521 }
pankso@1 522
pankso@16 523 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 524 # but it doesn't handle EXTRAVERSION.
pankso@1 525 packit() {
pankso@1 526 set_paths
pankso@55 527 echo "Pack: $PACKAGE $VERSION"
pankso@1 528 separator
pankso@44 529 if grep -q ^genpkg_rules $receipt; then
pankso@16 530 gettext -e "Executing: genpkg_rules\n"
pankso@16 531 cd $pkgdir
pankso@98 532 mkdir -p $fs && genpkg_rules || echo -e \
pankso@98 533 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
pankso@16 534 fi
pankso@98 535
pankso@98 536 # First QA check to stop now if genpkg_rules failed.
pankso@98 537 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 538 exit 1
pankso@98 539 fi
pankso@98 540
pankso@44 541 cd $taz
pankso@1 542 for file in receipt description.txt
pankso@1 543 do
pankso@1 544 [ ! -f "../$file" ] && continue
pankso@1 545 gettext "Copying"; echo -n " $file..."
pankso@1 546 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 547 done
pankso@119 548 copy_generic_files
pankso@16 549
paul@62 550 # Create files.list with redirecting find output.
pankso@16 551 gettext "Creating the list of files..." && cd $fs
pankso@16 552 find . -type f -print > ../files.list
pankso@16 553 find . -type l -print >> ../files.list
pankso@16 554 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 555 status
pankso@43 556
pankso@119 557 # Strip and stuff files.
pankso@43 558 strip_package
pankso@43 559
pankso@43 560 # Md5sum of files.
pankso@16 561 gettext "Creating md5sum of files..."
pankso@16 562 while read file; do
pankso@16 563 [ -L "fs$file" ] && continue
pankso@16 564 [ -f "fs$file" ] || continue
pankso@16 565 case "$file" in
pankso@16 566 /lib/modules/*/modules.*|*.pyc) continue;;
pankso@16 567 esac
pankso@16 568 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 569 done < files.list > md5sum
pankso@16 570 status
pankso@16 571 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 572 description.txt 2> /dev/null | awk \
pankso@16 573 '{ sz=$1 } END { print sz }')
pankso@16 574
pankso@16 575 # Build cpio archives.
pankso@16 576 gettext "Compressing the fs... "
pankso@16 577 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 578 rm -rf fs
pankso@16 579 status
pankso@16 580 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 581 md5sum description.txt 2> /dev/null | awk \
pankso@16 582 '{ sz=$1 } END { print sz }')
pankso@16 583 gettext "Updating receipt sizes..."
pankso@16 584 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 585 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 586 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 587 status
pankso@16 588
pankso@16 589 # Set extra version.
pankso@16 590 if [ "$EXTRAVERSION" ]; then
pankso@16 591 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 592 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 593 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 594 status
pankso@16 595 fi
pankso@16 596
pankso@16 597 # Compress.
pankso@16 598 gettext "Creating full cpio archive... "
pankso@16 599 find . -print | cpio -o -H newc --quiet > \
pankso@16 600 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 601 status
pankso@16 602 gettext "Restoring original package tree... "
pankso@16 603 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 604 status
pankso@16 605 rm fs.cpio.lzma && cd ..
pankso@43 606
pankso@43 607 # QA and give info.
pankso@43 608 tazpkg=$(ls *.tazpkg)
pankso@43 609 packit_quality
pankso@43 610 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 611 }
pankso@1 612
paul@62 613 # Verify package quality and consistency.
pankso@8 614 packit_quality() {
pankso@157 615 #gettext "QA: Checking for broken link..."
pankso@157 616 #link=$(find $fs/usr -type l -follow)
pankso@157 617 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@157 618 #status
pankso@142 619
pankso@142 620 # Exit if any error found in log file.
pankso@33 621 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 622 rm -f $command && exit 1
pankso@8 623 fi
pankso@142 624
pankso@44 625 gettext "QA: Checking for empty package..."
pankso@45 626 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@45 627 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 628 echo -e "\nERROR: empty package"
pankso@32 629 rm -f $command && exit 1
pankso@8 630 else
pankso@134 631 # Ls sort by name so the first file is the one we want.
pankso@136 632 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 633 status
pankso@154 634 if [ -f "$old" ]; then
pankso@154 635 echo -n "Removing old: $(basename $old)"
pankso@135 636 rm -f $old && status
pankso@154 637 fi
pankso@134 638 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 639 sed -i /^${pkg}$/d $broken
pankso@8 640 fi
pankso@8 641 }
pankso@8 642
pankso@1 643 #
pankso@1 644 # Commands
pankso@1 645 #
pankso@1 646
pankso@1 647 case "$1" in
pankso@32 648 usage|help|-u|-h)
pankso@1 649 usage ;;
pankso@1 650 list-wok)
pankso@52 651 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 652 separator
pankso@1 653 cd $WOK && ls -1
pankso@1 654 separator
pankso@1 655 echo -n "Packages: " && ls | wc -l
pankso@1 656 echo "" ;;
pankso@69 657 search)
pankso@69 658 # Just a simple search function, we dont need more actually.
pankso@69 659 query="$2"
pankso@69 660 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 661 separator
pankso@69 662 cd $WOK && ls -1 | grep "$query"
pankso@69 663 separator && echo "" ;;
pankso@1 664 setup)
pankso@1 665 # Setup a build environment
pankso@1 666 check_root
pankso@11 667 echo "Cook: setting up the environment" | log
pankso@1 668 gettext -e "\nSetting up your environment\n"
pankso@1 669 separator && cd $SLITAZ
pankso@52 670 init_db_files
pankso@1 671 gettext -e "Checking for packages to install...\n"
pankso@29 672 for pkg in $SETUP_PKGS
pankso@1 673 do
pankso@52 674 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
pankso@1 675 done
pankso@1 676
pankso@1 677 # Handle --options
pankso@1 678 case "$2" in
pankso@49 679 --wok|-w)
pankso@52 680 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
pankso@52 681 tazpkg get-install mercurial
paul@62 682 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
pankso@176 683 hg clone $WOK_URL ;;
pankso@1 684 esac
pankso@1 685
pankso@1 686 # SliTaz group and permissions
pankso@1 687 if ! grep -q ^slitaz /etc/group; then
pankso@1 688 gettext -e "Adding group: slitaz\n"
pankso@1 689 addgroup slitaz
pankso@1 690 fi
pankso@1 691 gettext -e "Setting permissions for slitaz group...\n"
pankso@1 692 chown -R root.slitaz $SLITAZ
pankso@1 693 chmod -R g+w $SLITAZ
pankso@1 694 separator
pankso@1 695 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 696 test)
pankso@9 697 # Test a cook environment.
pankso@13 698 echo "Cook test: testing the cook environment" | log
pankso@9 699 [ ! -d "$WOK" ] && exit 1
pankso@9 700 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 701 cook cooktest ;;
pankso@1 702 new)
pankso@1 703 # Create the package folder and an empty receipt.
pankso@1 704 pkg="$2"
pankso@1 705 [ "$pkg" ] || usage
pankso@1 706 echo ""
pankso@1 707 if [ -d "$WOK/$pkg" ]; then
paul@62 708 echo -n "$pkg " && gettext "package already exists."
pankso@1 709 echo -e "\n" && exit 1
pankso@1 710 fi
pankso@1 711 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 712 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 713 gettext "Preparing the package receipt..."
pankso@1 714 cp $DATA/receipt .
pankso@1 715 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@1 716 status && echo "" ;;
pankso@1 717 list)
pankso@1 718 # Cook a list of packages (better use the Cooker since it will order
pankso@1 719 # packages before executing cook).
pankso@1 720 check_root
pankso@1 721 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 722 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 723 echo -e " $2\n" && exit 1
pankso@13 724 echo "Cook list starting: $2" | log
pankso@1 725 for pkg in $(cat $2)
pankso@1 726 do
pankso@1 727 cook $pkg || broken
pankso@1 728 done ;;
pankso@1 729 clean-wok)
pankso@1 730 check_root
pankso@1 731 gettext -e "\nCleaning all packages files..."
pankso@1 732 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 733 status && echo "" ;;
pankso@1 734 clean-src)
pankso@1 735 check_root
paul@62 736 gettext -e "\nCleaning all packages sources..."
pankso@1 737 rm -rf $WOK/*/source
pankso@1 738 status && echo "" ;;
pankso@1 739 pkglist)
paul@62 740 # Create suitable packages list for TazPKG and only for built packages.
pankso@1 741 [ "$2" ] && PKGS="$2"
pankso@1 742 [ ! -d "$PKGS" ] && \
paul@62 743 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
pankso@133 744 echo "cook:pkglist" > $command
paul@62 745 echo "Cook pkglist: Creating all packages lists" | log
pankso@1 746 gettext -e "\nCreating lists for:"; echo " $PKGS"
pankso@1 747 separator
pankso@133 748 cd $PKGS
pankso@148 749 rm -f packages.* files.*
pankso@1 750 gettext -e "Creating: packages.list\n"
pankso@85 751 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@1 752 gettext -e "Creating: packages.md5\n"
pankso@1 753 md5sum *.tazpkg > $PKGS/packages.md5
pankso@1 754 gettext -e "Creating: packages.desc\n"
pankso@1 755 gettext -e "Creating: packages.equiv\n"
pankso@1 756 cd $WOK
pankso@1 757 for pkg in *
pankso@1 758 do
pankso@1 759 unset_receipt
pankso@1 760 . $pkg/receipt
paul@153 761 # packages.desc lets us search easily in DB
pankso@1 762 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 763 cat >> $PKGS/packages.desc << EOT
pankso@1 764 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 765 EOT
pankso@1 766 # Packages.equiv is used by tazpkg install to check depends.
pankso@1 767 for i in $PROVIDE; do
pankso@1 768 DEST=""
pankso@1 769 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 770 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 771 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 772 $PKGS/packages.equiv
pankso@1 773 else
pankso@1 774 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 775 fi
pankso@1 776 done
pankso@1 777 fi
pankso@1 778 done
pankso@155 779 cd $PKGS
pankso@155 780
paul@153 781 # packages.txt (redundancy list, all info is in pkgs desc).
pankso@148 782 touch packages.txt
pankso@148 783
pankso@1 784 # files.list.lzma
pankso@156 785 gettext -e "Creating: files.list.lzma\n"
pankso@148 786 touch files.list
pankso@148 787 lzma e files.list files.list.lzma
pankso@148 788
pankso@1 789 separator
pankso@1 790 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@133 791 echo -e "Packages: $nb\n"
pankso@133 792 rm -f $command ;;
pankso@1 793 *)
pankso@1 794 # Just cook and generate a package.
pankso@1 795 check_root
pankso@1 796 time=$(date +%s)
pankso@1 797 pkg="$1"
pankso@1 798 [ -z "$pkg" ] && usage
pankso@44 799 receipt="$WOK/$pkg/receipt"
pankso@1 800 check_pkg_in_wok && echo ""
pankso@47 801
pankso@128 802 # Display and log info if cook process stopped.
pankso@128 803 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 804 tee -a $LOGS/$pkg.log' INT
pankso@128 805
pankso@47 806 # Skip blocked, 3 lines also for the Cooker.
pankso@151 807 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
pankso@47 808 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 809 fi
pankso@47 810
pankso@47 811 # Log and source receipt.
pankso@56 812 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 813 echo "cook:$pkg" > $command
pankso@1 814 unset inst
pankso@1 815 unset_receipt
pankso@44 816 . $receipt
pankso@1 817
pankso@1 818 # Handle --options
pankso@1 819 case "$2" in
pankso@1 820 --clean|-c)
pankso@49 821 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 822 cd $WOK/$pkg && rm -rf install taz source
pankso@1 823 status && echo "" && exit 0 ;;
pankso@1 824 --install|-i)
pankso@1 825 inst='yes' ;;
pankso@49 826 --getsrc|-gs)
pankso@49 827 gettext "Getting source for:"; echo " $pkg"
pankso@45 828 separator && get_source
pankso@39 829 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 830 --block|-b)
pankso@49 831 gettext "Blocking:"; echo -n " $pkg"
pankso@49 832 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 833 status && echo "" && exit 0 ;;
pankso@49 834 --unblock|-ub)
pankso@49 835 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 836 sed -i "/^${pkg}$/"d $blocked
pankso@49 837 status && echo "" && exit 0 ;;
pankso@1 838 esac
pankso@1 839
paul@62 840 # Check if wanted is built now so we have separate log files.
pankso@1 841 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
pankso@138 842 if ! grep -q "^$WANTED$" $broken; then
pankso@137 843 cook "$WANTED"
pankso@137 844 fi
pankso@1 845 fi
pankso@1 846
pankso@1 847 # Cook and pack or exit on error and log everything.
pankso@97 848 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 849 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 850 cookit_quality
pankso@26 851 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 852 clean_log
pankso@33 853
pankso@33 854 # Exit if any error in packing.
pankso@33 855 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 856 debug_info | tee -a $LOGS/$pkg.log
pankso@33 857 rm -f $command && exit 1
pankso@33 858 fi
pankso@16 859
pankso@1 860 # Time and summary
pankso@1 861 time=$(($(date +%s) - $time))
pankso@1 862 summary | tee -a $LOGS/$pkg.log
pankso@50 863 echo ""
pankso@1 864
pankso@1 865 # Install package if requested
pankso@1 866 if [ "$inst" ]; then
pankso@1 867 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 868 cd $PKGS && tazpkg install \
pankso@1 869 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 870 else
paul@62 871 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 872 exit 1
pankso@1 873 fi
pankso@1 874 fi
pankso@9 875 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 876 # You want automation: use the Cooker Build Bot.
pankso@1 877 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 878 rm -f $command ;;
pankso@1 879 esac
pankso@1 880
pankso@1 881 exit 0